/* Header File For Performance Reader User Code
 *Includes syscall related stuff
 * 
 * lowpowered by: canturk isci / canturk@princeton.edu / CANOO
 */


/* For syscalls*/
#include <sys/syscall.h>
/* includes asm/unistd.h & bits/syscall.h */
#include <errno.h>
#include <linux/errno.h>

/* I AM USING SYSCALL # 222 FOR MY SYSCALL ASM/UNISTD.H GOES UP TO 221 */
#define MY_SYSCALL_NOselect_events 223 /* 222 is for getCPUinfo, so I go on from 223 */
#define MY_SYSCALL_NOreset_event_counter 224 /* 222 is for getCPUinfo, so I go on from 223 */
#define MY_SYSCALL_NOstart_event_counter 225 /* 222 is for getCPUinfo, so I go on from 223 */
#define MY_SYSCALL_NOstop_event_counter 226 /* 222 is for getCPUinfo, so I go on from 223 */
#define MY_SYSCALL_NOget_event_counts 227 /* 222 is for getCPUinfo, so I go on from 223 */
#define MY_SYSCALL_NOset_replay_MSRs 228 /* 222 is for getCPUinfo, so I go on from 223 */

/* DEFINE THE SYSCALL NUMBERS FOR unistd.h */
#define __NR_select_events          MY_SYSCALL_NOselect_events
#define __NR_reset_event_counter    MY_SYSCALL_NOreset_event_counter
#define __NR_start_event_counter    MY_SYSCALL_NOstart_event_counter
#define __NR_stop_event_counter     MY_SYSCALL_NOstop_event_counter
#define __NR_get_event_counts       MY_SYSCALL_NOget_event_counts
#define __NR_set_replay_MSRs        MY_SYSCALL_NOset_replay_MSRs

/* DEFINE THE SYSCALL NUMBERS FOR bits/syscall.h */
#define SYS_select_events          MY_SYSCALL_NOselect_events
#define SYS_reset_event_counter    MY_SYSCALL_NOreset_event_counter
#define SYS_start_event_counter    MY_SYSCALL_NOstart_event_counter
#define SYS_stop_event_counter     MY_SYSCALL_NOstop_event_counter
#define SYS_get_event_counts       MY_SYSCALL_NOget_event_counts
#define SYS_set_replay_MSRs        MY_SYSCALL_NOset_replay_MSRs

/* DEFINE MY syscall */
inline _syscall2(int, select_events, void *, ESCR_FieldsFromUser, void *, CCCR_FieldsFromUser);
inline _syscall1(int, reset_event_counter, unsigned int, CounterAddress);
inline _syscall1(int, start_event_counter, unsigned int, CCCRAddress);
inline _syscall1(int, stop_event_counter, unsigned int, CCCRAddress);
inline _syscall1(int, get_event_counts, unsigned long long *, datatouser);
inline _syscall2(int, set_replay_MSRs, unsigned int, MSRaddress, unsigned long long, setbits64);
